#include <iostream>
#include <fstream>
using namespace std;

void writeout(int key, char* buffer, int length, fstream* FID) {
  FID->write((char*)(&key), 4);
  FID->write((char*)(&length), 4);
  FID->write(buffer, length);
}

bool readback(fstream* FID) {
  int key;
  int length;
  char buffer[125];

  if(!FID->read((char*)(&key), 4)) return false;
  FID->read((char*)(&length), 4);
  cout << key << ", " << length << endl;
  FID->read(buffer, length);
  int ID;
  memcpy(&ID, buffer, 4);
  cout << ID << endl;
}

int main(int argc, char** argv) {

  int ID;
  char *title = new char[100];
  char date[11];
  int length;
  int cost;

  if (argc != 2) {
    cout << "Usage: complex <outfile>.\n";
    exit(-1);
  }

  fstream *myFile = new fstream;

  myFile->open(argv[1], ios::trunc | ios::in | ios::out | ios::binary );

  char buffer[125];
  int msglength;
  while (cin >> ID >> title >> date >> length >> cost) {
    cout << ID << ", " << title << ", " << date << ", "
         << length << ", " << cost << endl;
    memcpy(buffer, &ID, 4);
    memcpy(&(buffer[4]), title, strlen(title));
    msglength = 4 + strlen(title);
    memcpy(&(buffer[msglength]), date, 10);
    memcpy(&(buffer[msglength+10]), &length, 4);
    memcpy(&(buffer[msglength+14]), &cost, 4);
    msglength += 18;
    writeout(ID, buffer, msglength, myFile);
  }

  myFile->seekg(0);  
  while (readback(myFile)) {}
  myFile->close();
  exit(0);
}
